using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

using PrivateDataCommon;

namespace PrivateDataCore
{
    /// <summary>
    /// Data key
    /// </summary>
    internal class DataKey
    {
        /// <summary>
        /// Constructs DataKey from a byte array
        /// </summary>
        /// <param name="key">Byte contents of the key</param>
        public DataKey(byte[] key)
        {
            bytes = key;
        }

        /// <summary>
        /// Constructs DataKey by reading it from a stream
        /// </summary>
        /// <param name="keyStream">Stream containing the key</param>
        public DataKey(Stream keyStream)
        {
            bytes = Utils.ReadStream(keyStream);
        }

        /// <summary>
        /// Byte contents of the key
        /// </summary>
        public byte[] Bytes
        {
            get
            {
                return bytes;
            }
        }

        private byte[] bytes;
    }
}
