using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

using PrivateDataCommon;

namespace PrivateDataCore
{
    public class FolderItem : Item
    {
        private FolderItem(Metadata metadata)
            : base(metadata)
        {
            items = new List<ItemID>();
        }

        private FolderItem(ItemID id, Metadata metadata, Content content)
            : base(id, metadata)
        {
            items = new List<ItemID>();

            Stream stream = content.DetachData();
            try
            {
                int count = Utils.ReadIntFromStream(stream);
                for (int i = 0; i < count; i++)
                {
                    ItemID item = new ItemID(stream);
                    items.Add(item);
                }

                notes = Utils.ReadStringFromStream(stream);
            }
            finally
            {
                stream.Close();
            }
        }

        public override Content GenerateContent()
        {
            MemoryStream memoryStream = new MemoryStream();

            Utils.WriteIntToStream(items.Count, memoryStream, false/*estimate*/);
            foreach (ItemID id in items)
            {
                id.WriteToStream(memoryStream, false/*estimate*/);
            }

            Utils.WriteStringToStream(notes, memoryStream, false/*estimate*/);

            return new Content(memoryStream);
        }

        public List<ItemID> Items
        {
            get
            {
                return items;
            }
        }

        private List<ItemID> items;
    }
}
