using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

using PrivateDataCommon;

namespace PrivateDataCore.ItemTypes
{
    public class Email : Item
    {
        private Email(Metadata metadata)
            : base(metadata)
        {
            // Nothing to do here
        }

        private Email(ItemID id, Metadata metadata, Content content)
            : base(id, metadata)
        {
            Stream stream = content.DetachData();
            try
            {
                emailAddress = Utils.ReadStringFromStream(stream);
                password = Utils.ReadStringFromStream(stream);
                smtp = Utils.ReadStringFromStream(stream);
                pop3 = Utils.ReadStringFromStream(stream);
                url = Utils.ReadStringFromStream(stream);
                notes = Utils.ReadStringFromStream(stream);
            }
            finally
            {
                stream.Close();
            }
        }

        public override Content GenerateContent()
        {
            MemoryStream memoryStream = new MemoryStream();

            Utils.WriteStringToStream(emailAddress, memoryStream, false/*estimate*/);
            Utils.WriteStringToStream(password, memoryStream, false/*estimate*/);
            Utils.WriteStringToStream(smtp, memoryStream, false/*estimate*/);
            Utils.WriteStringToStream(pop3, memoryStream, false/*estimate*/);
            Utils.WriteStringToStream(url, memoryStream, false/*estimate*/);
            Utils.WriteStringToStream(notes, memoryStream, false/*estimate*/);

            return new Content(memoryStream);
        }

        /// <summary>
        /// E-mail address
        /// </summary>
        public string EmailAddress
        {
            get
            {
                return emailAddress;
            }

            set
            {
                emailAddress = value;
            }
        }

        /// <summary>
        /// Password
        /// </summary>
        public string Password
        {
            get
            {
                return password;
            }

            set
            {
                password = value;
            }
        }

        /// <summary>
        /// SMTP server
        /// </summary>
        public string SMTP
        {
            get
            {
                return smtp;
            }

            set
            {
                smtp = value;
            }
        }

        /// <summary>
        /// POP3 server
        /// </summary>
        public string POP3
        {
            get
            {
                return pop3;
            }

            set
            {
                pop3 = value;
            }
        }

        /// <summary>
        /// URL
        /// </summary>
        public string URL
        {
            get
            {
                return url;
            }

            set
            {
                url = value;
            }
        }

        private string emailAddress = String.Empty;
        private string password = String.Empty;
        private string smtp = String.Empty;
        private string pop3 = String.Empty;
        private string url = String.Empty;
    }
}
