using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

using PrivateDataCommon;

namespace PrivateDataCore.ItemTypes
{
    public class GenericPassword : Item
    {
        private GenericPassword(Metadata metadata)
            : base(metadata)
        {
            // Nothing to do here
        }

        private GenericPassword(ItemID id, Metadata metadata, Content content)
            : base(id, metadata)
        {
            Stream stream = content.DetachData();
            try
            {
                inquirer = Utils.ReadStringFromStream(stream);
                username = Utils.ReadStringFromStream(stream);
                password = Utils.ReadStringFromStream(stream);
                notes = Utils.ReadStringFromStream(stream);
            }
            finally
            {
                stream.Close();
            }
        }

        public override Content GenerateContent()
        {
            MemoryStream memoryStream = new MemoryStream();

            Utils.WriteStringToStream(inquirer, memoryStream, false/*estimate*/);
            Utils.WriteStringToStream(username, memoryStream, false/*estimate*/);
            Utils.WriteStringToStream(password, memoryStream, false/*estimate*/);
            Utils.WriteStringToStream(notes, memoryStream, false/*estimate*/);

            return new Content(memoryStream);
        }

        /// <summary>
        /// Who asks for the password?
        /// </summary>
        public string Inquirer
        {
            get
            {
                return inquirer;
            }

            set
            {
                inquirer = value;
            }
        }

        /// <summary>
        /// Username
        /// </summary>
        public string Username
        {
            get
            {
                return username;
            }

            set
            {
                username = value;
            }
        }

        /// <summary>
        /// Password
        /// </summary>
        public string Password
        {
            get
            {
                return password;
            }

            set
            {
                password = value;
            }
        }

        private string inquirer = String.Empty;
        private string username = String.Empty;
        private string password = String.Empty;
    }
}
