using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

using PrivateDataCommon;

namespace PrivateDataCore.ItemTypes
{
    public class Note : Item
    {
        private Note(Metadata metadata)
            : base(metadata)
        {
            // Nothing to do here
        }

        private Note(ItemID id, Metadata metadata, Content content)
            : base(id, metadata)
        {
            Stream stream = content.DetachData();
            try
            {
                notes = Utils.ReadStringFromStream(stream);
            }
            finally
            {
                stream.Close();
            }
        }

        public override Content GenerateContent()
        {
            MemoryStream memoryStream = new MemoryStream();

            Utils.WriteStringToStream(notes, memoryStream, false/*estimate*/);

            return new Content(memoryStream);
        }
    }
}
