using System;
using System.Collections.Generic;
using System.Text;

using PrivateDataCommon;
using PrivateDataCore;

namespace PrivateData.AsyncOperations
{
    internal class ArchiveOperation : AsyncOperation
    {
        public ArchiveOperation(
            DataManager dataManager,
            string fileName,
            string password,
            uint iterationCount)
        {
            this.dataManager = dataManager;
            this.fileName = fileName;
            this.password = password;
            this.iterationCount = iterationCount;
        }

        public override string Message
        {
            get
            {
                return Properties.Resources.ArchiveOperationMessage;
            }
        }

        public override bool Cancellable
        {
            get
            {
                // Archivation can take a long time; it must be cancellable
                return true;
            }
        }

        protected override void Execute(SlowOperationController controller)
        {
            dataManager.BackupData(
                fileName,
                password,
                iterationCount,
                controller);
        }

        private DataManager dataManager;
        private string fileName;
        private string password;
        private uint iterationCount;
    }
}
