using System;
using System.Collections.Generic;
using System.Text;

using PrivateDataCommon;
using PrivateDataCore;

namespace PrivateData.AsyncOperations
{
    internal class CompactFileOperation : AsyncOperation
    {
        public CompactFileOperation(DataManager dataManager)
        {
            this.dataManager = dataManager;
        }

        public override string Message
        {
            get
            {
                return Properties.Resources.CompactFileOperationMessage;
            }
        }

        public override bool Cancellable
        {
            get
            {
                // Compacting the file is a really slow operation; it should
                // therefore be cancellable
                return true;
            }
        }

        protected override void Execute(SlowOperationController controller)
        {
            dataManager.Defragment(controller);
        }

        private DataManager dataManager;
    }
}
