using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

using PrivateDataCommon;
using PrivateDataCore;

namespace PrivateData.AsyncOperations
{
    internal class ExportItemOperation : AsyncOperation
    {
        public ExportItemOperation(IFileItem item, string fileName)
        {
            this.item = item;
            this.fileName = fileName;
        }

        public override string Message
        {
            get
            {
                return Properties.Resources.ExportItemOperationMessage;
            }
        }

        public override bool Cancellable
        {
            get
            {
                // Exporting a large item can take some time, so the operation
                // must be cancellable
                return true;
            }
        }

        protected override void Execute(SlowOperationController controller)
        {
            FileStream file = File.Create(fileName);
            try
            {
                item.Export(file, controller);
            }
            finally
            {
                file.Close();
            }
        }

        IFileItem item;
        string fileName;
    }
}
