using System;
using System.Collections.Generic;
using System.Text;

using PrivateDataCommon;
using PrivateDataCore;

namespace PrivateData.AsyncOperations
{
    internal class LoginOperation : AsyncOperation
    {
        public LoginOperation(
            DataManager dataManager,
            string dataPath,
            string password)
        {
            this.dataManager = dataManager;
            this.dataPath = dataPath;
            this.password = password;
        }

        public override string Message
        {
            get
            {
                return Properties.Resources.LoginOperationMessage;
            }
        }

        public override bool Cancellable
        {
            get
            {
                // Login must be cancellable because, in case of a corrupted
                // storage, we can get a really big iteration count so we'd
                // better give the user a chance to stop it
                return true;
            }
        }

        protected override void Execute(SlowOperationController controller)
        {
            passwordCorrect = dataManager.Login(dataPath, password, controller);
        }

        public bool PasswordCorrect
        {
            get
            {
                return passwordCorrect;
            }
        }

        private DataManager dataManager;
        private string dataPath;
        private string password;

        private bool passwordCorrect;
    }
}
