using System;
using System.Collections.Generic;
using System.Text;

using PrivateDataCommon;
using PrivateDataCore;

namespace PrivateData.AsyncOperations
{
    internal class MoveItemToFolderOperation : AsyncOperation
    {
        public MoveItemToFolderOperation(
            DataManager dataManager,
            ItemID item,
            ItemID folder)
        {
            this.dataManager = dataManager;
            this.item = item;
            this.folder = folder;
        }

        public override string Message
        {
            get
            {
                return Properties.Resources.MoveItemToFolderOperationMessage;
            }
        }

        public override bool Cancellable
        {
            get
            {
                // Relatively fast operation; let's not make it cancellable
                // so that we avoid leaving the item orphaned in the root
                return false;
            }
        }

        protected override void Execute(SlowOperationController controller)
        {
            dataManager.MoveItemToFolder(item, folder, controller);
        }

        private DataManager dataManager;
        private ItemID item;
        private ItemID folder;
    }
}
