using System;
using System.Collections.Generic;
using System.Text;

using PrivateDataCommon;
using PrivateDataCore;

namespace PrivateData.AsyncOperations
{
    internal class RenameItemOperation : AsyncOperation
    {
        public RenameItemOperation(
            DataManager dataManager,
            ItemID item,
            string name)
        {
            this.dataManager = dataManager;
            this.item = item;
            this.name = name;
        }

        public override string Message
        {
            get
            {
                return Properties.Resources.RenameItemOperationMessage;
            }
        }

        public override bool Cancellable
        {
            get
            {
                // No need to cancel this operation; it should be relatively short
                return false;
            }
        }

        protected override void Execute(SlowOperationController controller)
        {
            dataManager.RenameItem(item, name, controller);
        }

        private DataManager dataManager;
        private ItemID item;
        private string name;
    }
}
