using System;
using System.Collections.Generic;
using System.Text;

using PrivateDataCommon;
using PrivateDataCore;

namespace PrivateData.AsyncOperations
{
    internal class RestoreOperation : AsyncOperation
    {
        public RestoreOperation(
            DataManager dataManager,
            string fileName,
            string password)
        {
            this.dataManager = dataManager;
            this.fileName = fileName;
            this.password = password;
        }

        public override string Message
        {
            get
            {
                return Properties.Resources.RestoreOperationMessage;
            }
        }

        public override bool Cancellable
        {
            get
            {
                // Restore can take a really long time; it must be cancellable
                return true;
            }
        }

        protected override void Execute(SlowOperationController controller)
        {
            dataManager.RestoreData(fileName, password, controller);
        }

        private DataManager dataManager;
        private string fileName;
        private string password;
    }
}
