using System;
using System.Collections.Generic;
using System.Text;

using PrivateDataCommon;
using PrivateDataCore;

namespace PrivateData.AsyncOperations
{
    internal class StoreItemOperation : AsyncOperation
    {
        public StoreItemOperation(
            DataManager dataManager,
            Item item,
            ItemID folder)
        {
            this.dataManager = dataManager;
            this.item = item;
            this.folder = folder;
        }

        public override string Message
        {
            get
            {
                return Properties.Resources.StoreItemOperationMessage;
            }
        }

        public override bool Cancellable
        {
            get
            {
                // Storing a really large item (like a file or picture) must
                // be cancellable
                return true;
            }
        }

        protected override void Execute(SlowOperationController controller)
        {
            dataManager.StoreItem(item, folder, controller);
        }

        private DataManager dataManager;
        private Item item;
        private ItemID folder;
    }
}
