using System;
using System.Collections.Generic;
using System.Text;

using PrivateDataCommon;
using PrivateDataCore;

namespace PrivateData.AsyncOperations
{
    internal class TestLoginSpeedOperation : AsyncOperation
    {
        public TestLoginSpeedOperation(uint iterationCount)
        {
            this.iterationCount = iterationCount;
        }

        public override string Message
        {
            get
            {
                return Properties.Resources.TestLoginSpeedOperationMessage;
            }
        }

        public override bool Cancellable
        {
            get
            {
                // This is a long operation that does nothing;
                // why not be cancellable?
                return true;
            }
        }

        protected override void Execute(SlowOperationController controller)
        {
            DataManager.TestLoginSpeed(iterationCount, controller);
        }

        private uint iterationCount;
    }
}
