using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using PrivateDataCore;

namespace PrivateData
{
    public partial class CreateStorageDialog : Form
    {
        public CreateStorageDialog(DataManager dataManager)
        {
            this.dataManager = dataManager;

            InitializeComponent();
        }

        public string DataPath
        {
            get
            {
                return dataPath;
            }
        }

        private void okButton_Click(object sender, EventArgs e)
        {
            SaveFileDialog saveFileDialog = new SaveFileDialog();
            saveFileDialog.Filter = "Private Data file (*.pds)|*.pds";
            if (saveFileDialog.ShowDialog() == DialogResult.OK)
            {
                dataPath = saveFileDialog.FileName;

                NewPasswordDialog newPasswordDialog
                    = new NewPasswordDialog(false/*changePassword*/);
                if (newPasswordDialog.ShowDialog() == DialogResult.OK)
                {
                    // TODO: iteration count
                    //const int iterationCount = 2500;
                    SecurityLevelDialog securityLevelDialog
                        = new SecurityLevelDialog();
                    if (securityLevelDialog.ShowDialog() == DialogResult.OK)
                    {
                        AsyncOperations.CreateStorageOperation createStorage
                            = new AsyncOperations.CreateStorageOperation(
                                dataManager,
                                dataPath,
                                newPasswordDialog.NewPassword,
                                securityLevelDialog.IterationCount);

                        new AsyncOperationUI(
                            createStorage,
                            this,
                            new EventHandler(createStorage_Succeeded),
                            new EventHandler(createStorage_Cancelled),
                            new EventHandler(createStorage_Failed));

                        createStorage.BeginExecute();
                    }
                }
            }
        }

        private void createStorage_Succeeded(object sender, EventArgs e)
        {
            DialogResult = DialogResult.OK;
            Close();
        }

        private void createStorage_Cancelled(object sender, EventArgs e)
        {
            // Create storage should not be cancellable
            throw new Exception(); // TODO: Fix exceptions
        }

        private void createStorage_Failed(object sender, EventArgs e)
        {
            MessageBox.Show("Creation failed");

            DialogResult = DialogResult.Abort;
            Close();
        }

        private DataManager dataManager;
        private string dataPath;
    }
}