using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

using PrivateDataCore;
using PrivateDataCore.ItemTypes;

namespace PrivateData.ItemControls
{
    public partial class BankAccountControl : UserControl, IEditItemControl
    {
        private BankAccountControl()
        {
            InitializeComponent();
        }

        public BankAccountControl(BankAccount item)
        {
            InitializeComponent();

            this.item = item;

            financialInstitutionTextBox.Text = item.FinancialInstitution;
            accountTypeComboBox.Text = item.AccountType;
            accountNumberTextBox.Text = item.AccountNumber;
            routingNumberTextBox.Text = item.RoutingNumber;
            pinTextBox.Text = item.PIN;
            customerSupportTextBox.Text = item.CustomerSupport;
            urlTextBox.Text = item.URL;
            usernameTextBox.Text = item.Username;
            passwordTextBox.Text = item.Password;
            notesTextBox.Text = item.Notes;
        }

        public bool Save()
        {
            if (textChanged)
            {
                item.FinancialInstitution = financialInstitutionTextBox.Text;
                item.AccountType = accountTypeComboBox.Text;
                item.AccountNumber = accountNumberTextBox.Text;
                item.RoutingNumber = routingNumberTextBox.Text;
                item.PIN = pinTextBox.Text;
                item.CustomerSupport = customerSupportTextBox.Text;
                item.URL = urlTextBox.Text;
                item.Username = usernameTextBox.Text;
                item.Password = passwordTextBox.Text;
                item.Notes = notesTextBox.Text;

                return true;
            }
            else
            {
                return false;
            }
        }

        private void HandleUserInput(object sender, EventArgs e)
        {
            textChanged = true;
        }

        private void tabControl_GotFocus(object sender, EventArgs e)
        {
            if (tabControl.TabPages[tabControl.SelectedIndex].Name == accountTabPage.Name)
            {
                financialInstitutionTextBox.Focus();
            }
            else if (tabControl.TabPages[tabControl.SelectedIndex].Name == webTabPage.Name)
            {
                urlTextBox.Focus();
            }
            else if (tabControl.TabPages[tabControl.SelectedIndex].Name == notesTabPage.Name)
            {
                notesTextBox.Focus();
            }
        }

        private BankAccount item;
        private bool textChanged;
    }
}
