using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

using PrivateDataCore;
using PrivateDataCore.ItemTypes;

namespace PrivateData.ItemControls
{
    public partial class CellPhoneControl : UserControl, IEditItemControl
    {
        private CellPhoneControl()
        {
            InitializeComponent();
        }
        public CellPhoneControl(CellPhone item)
        {
            InitializeComponent();

            this.item = item;

            manufacturerComboBox.Text = item.Manufacturer;
            modelTextBox.Text = item.Model;
            imeiTextBox.Text = item.Imei;
            pinTextBox.Text = item.PIN;
            securityCodeTextBox.Text = item.SecurityCode;
            phoneNumberTextBox.Text = item.PhoneNumber;
            customerSupportTextBox.Text = item.CustomerSupport;
            urlTextBox.Text = item.URL;
            usernameTextBox.Text = item.Username;
            passwordTextBox.Text = item.Password;
            notesTextBox.Text = item.Notes;
        }

        public bool Save()
        {
            if (textChanged)
            {
                item.Manufacturer = manufacturerComboBox.Text;
                item.Model = modelTextBox.Text;
                item.Imei = imeiTextBox.Text;
                item.PIN = pinTextBox.Text;
                item.SecurityCode = securityCodeTextBox.Text;
                item.PhoneNumber = phoneNumberTextBox.Text;
                item.CustomerSupport = customerSupportTextBox.Text;
                item.URL = urlTextBox.Text;
                item.Username = usernameTextBox.Text;
                item.Password = passwordTextBox.Text;
                item.Notes = notesTextBox.Text;

                return true;
            }
            else
            {
                return false;
            }
        }

        private void HandleUserInput(object sender, EventArgs e)
        {
            textChanged = true;
        }

        private void tabControl_GotFocus(object sender, EventArgs e)
        {
            if (tabControl.TabPages[tabControl.SelectedIndex].Name == phoneTabPage.Name)
            {
                manufacturerComboBox.Focus();
            }
            else if (tabControl.TabPages[tabControl.SelectedIndex].Name == serviceTabPage.Name)
            {
                phoneNumberTextBox.Focus();
            }
            else if (tabControl.TabPages[tabControl.SelectedIndex].Name == notesTabPage.Name)
            {
                notesTextBox.Focus();
            }
        }

        private CellPhone item;
        private bool textChanged;
    }
}
