using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

using PrivateDataCore;
using PrivateDataCore.ItemTypes;

namespace PrivateData.ItemControls
{
    public partial class EmailControl : UserControl, IEditItemControl
    {
        private EmailControl()
        {
            InitializeComponent();
        }

        public EmailControl(Email item)
        {
            InitializeComponent();

            this.item = item;

            emailTextBox.Text = item.EmailAddress;
            passwordTextBox.Text = item.Password;
            smtpTextBox.Text = item.SMTP;
            pop3TextBox.Text = item.POP3;
            notesTextBox.Text = item.Notes;
        }

        public bool Save()
        {
            if (textChanged)
            {
                item.EmailAddress = emailTextBox.Text;
                item.Password = passwordTextBox.Text;
                item.SMTP = smtpTextBox.Text;
                item.POP3 = pop3TextBox.Text;
                item.Notes = notesTextBox.Text;

                return true;
            }
            else
            {
                return false;
            }
        }

        private void tabControl_GotFocus(object sender, EventArgs e)
        {
            if (tabControl.TabPages[tabControl.SelectedIndex].Name == emailTabPage.Name)
            {
                emailTextBox.Focus();
            }
            else if (tabControl.TabPages[tabControl.SelectedIndex].Name == notesTabPage.Name)
            {
                notesTextBox.Focus();
            }
        }

        private void HandleUserInput(object sender, EventArgs e)
        {
            textChanged = true;
        }

        private Email item;
        private bool textChanged;
    }
}
