using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using PrivateDataCore;
using PrivateDataCore.ItemTypes;

namespace PrivateData.ItemControls
{
    public partial class GenericPasswordControl : UserControl, IEditItemControl
    {
        private GenericPasswordControl()
        {
            InitializeComponent();
        }

        public GenericPasswordControl(GenericPassword item)
        {
            InitializeComponent();

            this.item = item;

            inquirerTextBox.Text = item.Inquirer;
            usernameTextBox.Text = item.Username;
            passwordTextBox.Text = item.Password;
            notesTextBox.Text = item.Notes;
        }

        public bool Save()
        {
            if (textChanged)
            {
                item.Inquirer = inquirerTextBox.Text;
                item.Username = usernameTextBox.Text;
                item.Password = passwordTextBox.Text;
                item.Notes = notesTextBox.Text;

                return true;
            }
            else
            {
                return false;
            }
        }

        private void tabControl_GotFocus(object sender, EventArgs e)
        {
            if (tabControl.TabPages[tabControl.SelectedIndex].Name == passwordTabPage.Name)
            {
                inquirerTextBox.Focus();
            }
            else if (tabControl.TabPages[tabControl.SelectedIndex].Name == notesTabPage.Name)
            {
                notesTextBox.Focus();
            }
        }

        private void HandleUserInput(object sender, EventArgs e)
        {
            textChanged = true;
        }

        private GenericPassword item;
        private bool textChanged;
    }
}

