using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

using PrivateDataCore;
using PrivateDataCore.ItemTypes;

namespace PrivateData.ItemControls
{
    public partial class NoteControl : UserControl, IEditItemControl
    {
        public NoteControl()
        {
            InitializeComponent();
        }

        public NoteControl(Note item)
        {
            InitializeComponent();

            this.item = item;

            notesTextBox.Text = item.Notes;
        }

        public bool Save()
        {
            if (textChanged)
            {
                item.Notes = notesTextBox.Text;

                return true;
            }
            else
            {
                return false;
            }
        }

        private void HandleUserInput(object sender, EventArgs e)
        {
            textChanged = true;
        }

        private void tabControl_GotFocus(object sender, EventArgs e)
        {
            if (tabControl.TabPages[tabControl.SelectedIndex].Name == notesTabPage.Name)
            {
                notesTextBox.Focus();
            }
        }

        private Note item;
        private bool textChanged;
    }
}
