using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace PrivateData
{
    public partial class ProgressDialog : Form
    {
        public ProgressDialog(AsyncOperation operation)
        {
            InitializeComponent();

            this.operation = operation;
            messageLabel.Text = operation.Message;

            // Attach a progress tracker to track the operation's progress
            new AsyncOperationProgressTracker(operation, progressBar);

            // If the operation is cancellable, attach the cancel button
            if (operation.Cancellable)
            {
                cancelButton.Enabled = true;
                cancelButton.Click += new EventHandler(cancelButton_Click);
            }
        }

        private void cancelButton_Click(object sender, EventArgs e)
        {
            operation.Cancel();
        }

        private AsyncOperation operation;
    }
}