using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using PrivateDataCore;
using PrivateDataCommon;
using PrivateData.AsyncOperations;

namespace PrivateData
{
    public partial class SecurityLevelDialog : Form
    {
        public SecurityLevelDialog()
        {
            InitializeComponent();
        }

        public uint IterationCount
        {
            get
            {
                return (uint)securityLevelTrackBar.Value;
            }
        }

        private void testButton_Click(object sender, EventArgs e)
        {
            if (testLoginSpeed == null)
            {
                // There is no test running - start one
                testLoginSpeed
                    = new TestLoginSpeedOperation((uint)securityLevelTrackBar.Value);

                new AsyncOperationProgressTracker(
                    testLoginSpeed,
                    speedTestProgressBar);

                // Subscribe to the operation's events
                testLoginSpeed.Succeeded
                    += new EventHandler(testLoginSpeed_Succeeded);
                testLoginSpeed.Cancelled
                    += new EventHandler(testLoginSpeed_Cancelled);
                testLoginSpeed.Failed
                    += new EventHandler(testLoginSpeed_Failed);

                UpdateControls();
                testLoginSpeed.BeginExecute();
            }
            else
            {
                // A test is already running - cancel it
                testLoginSpeed.Cancel();
            }
        }

        private void UpdateControls()
        {
            testSpeedButton.Text
                = testLoginSpeed == null
                    ? Properties.Resources.TestSpeedButtonStart
                    : Properties.Resources.TestSpeedButtonStop;
        }

        private void testLoginSpeed_Succeeded(object sender, EventArgs e)
        {
            // Since we're not using an AsyncOperationUI, we need to transfer
            // to the correct thread ourselves
            BeginInvoke(
                new EventHandler(TestFinished),
                sender,
                e);
        }

        private void testLoginSpeed_Cancelled(object sender, EventArgs e)
        {
            // Since we're not using an AsyncOperationUI, we need to transfer
            // to the correct thread ourselves
            BeginInvoke(
                new EventHandler(TestFinished),
                sender,
                e);
        }

        private void testLoginSpeed_Failed(object sender, EventArgs e)
        {
            // Since we're not using an AsyncOperationUI, we need to transfer
            // to the correct thread ourselves
            BeginInvoke(
                new EventHandler(TestFinished),
                sender,
                e);
        }

        private void TestFinished(object sender, EventArgs e)
        {
            testLoginSpeed = null;
            UpdateControls();
        }

        private TestLoginSpeedOperation testLoginSpeed;
    }
}