using System;
using System.Collections.Generic;
using System.Text;

using Microsoft.Win32;

namespace PrivateData
{
    class Settings
    {
        private Settings()
        {
        }

        public static string DataPath
        {
            get
            {
                RegistryKey key
                    = Registry.CurrentUser.OpenSubKey(privateDataKeyName);

                if (key != null)
                {
                    try
                    {
                        return (string)key.GetValue(dataPathValueName);
                    }
                    finally
                    {
                        key.Close();
                    }
                }
                else
                {
                    return null;
                }
            }

            set
            {
                RegistryKey key
                    = Registry.CurrentUser.CreateSubKey(privateDataKeyName);

                if (key == null)
                {
                    // Registry access exception
                    throw new Exception(); // TODO: Fix exceptions
                }

                try
                {
                    key.SetValue(dataPathValueName, value);
                }
                finally
                {
                    key.Close();
                }
            }
        }

        const string privateDataKeyName = @"Software\Milena Iordanova\Private Data";
        const string dataPathValueName = "Data path";
    }
}
